interface_active=""
npath="/etc/sysconfig/network-scripts/ifcfg-"
lan_numbers=""
last_octet=""
start_lan=""

function check_interface(){
	input="$1"
	count=$(ip a | grep -w UP | grep -v lo | awk '{print $2}' | sed "s/://g" | wc -l)
	out_for=0
	interface_active=""
	for inter in `ip a | grep -w UP | awk '{print $2}' | sed "s/://g"`; do
		if [[ "$inter" == "$input" ]] && [[ "${out_for}" -le "$count" ]]; then
			#echo -e "Card mạng "$input" tồn tại"
			interface_active=$input
		fi
		out_for=$((out_for+1))
	done
	[[ ! -z "${interface_active}" ]] && echo -e "Card mạng "${interface_active}" tồn tại \n" || { echo -e "Card mạng "$input" không tồn tại, thoát khỏi chương trình"; exit; }
	unset input		
}

function check_number(){
	input="$1"
	[[ -z "$input" ]] || [[ "$input" -ge 255 ]] || [[ "$input" -le 0 ]] && { echo -e "Chấp nhận giá trị số, khác rỗng,lớn hơn 0 và bé hơn 255"; exit ; }
	unset input
}

function add_ip(){
	ip_lan_format=$(echo "192.168."${last_octet}"."${start_lan}"")
	network_path=$(echo ""$npath""${interface_active}"")
	
#Đa số bạn sẽ đặt ip lan dạng 192.168.x.1 -> 192.168.x.7 nên bước này mình check file config có tồn tại không
	for i in {1..7}; do
		if [[ "${start_lan}" -eq 1 ]] && [[ -f "${network_path}:"$i"" ]]; then
			echo -e "File config network "${network_path}:"$i"" tồn tại \nKiểm tra lại, off card mạng lan và xoá để thay thế (nếu cần)"
			exit
		fi 
	done
	
	last_for=$((start_lan + lan_numbers))
	[[ "${last_for}" -ge 255 ]] && echo -e "Số lượng ip thêm vào không lớn hơn 255"
 
	for (( ip="${start_lan}"; ip<="${last_for}"; ip++))
	do
		echo -e "XXX Create: "${interface_active}":"$ip""
		echo -e "
DEVICE="${interface_active}":"$ip"
ONBOOT=yes
IPADDR=192.168."${last_octet}"."$ip"
NETMASK=255.255.255.0
" > "${network_path}:$ip"
		echo -e "XXX Up: "${network_path}:$ip""
		ifup "${network_path}:$ip"
		[[ "$?" -eq 0 ]] && echo -e "✅ Successfull add lan ip: 192.168."${last_octet}"."$ip" ✅ \n"		
	done
	
	echo -e "***Các ip lan mà bạn đã thêm*** \n"
	ip a | grep "192.168."${last_octet}"" | awk '{print $2}'
	echo -e "\n***Chúc bạn sức khoẻ, mai mắn và thành công*** \n"
}

function main(){
	[[ `uname -r` != *"el"* ]] && { echo -e "Bạn không dùng Centos => Thoát chương trình"; exit; }
	read -p "Điền tên card mạng đang hoạt động: " interface_active
	check_interface "${interface_active}"
	
	echo -e "\t***IP Lan được tạo có dạng 192.168.X.Y***

[+] Với X là Octet cuối cùng của ip
[+] Với Y là ip lan bắt đầu
\t****Giả sử ip bạn là: 123.124.125.126 và bạn cần 10 ip lan bắt đầu là 192.168.126.20****
[+] X điền 126
[+] Y điền 20
[+] Số lượng ip điền 10

*Lưu ý: 
[X] Không chấp nhận giá trị octet ip cuối cùng bằng 0 -> 5
[Y] Ip lan bắt đầu và số lượng ip chấp nhận giá trị số, khác rỗng, lớn hơn 0 và bé hơn 255
"

	read -p "Điền X octest thứ 4 của ip gốc: " last_octet
	check_number "${last_octet}"
	[[ "$last_octet" -eq 0 ]] || [[ "$last_octet" -eq 1 ]] || [[ "$last_octet" -eq 2 ]] || [[ "$last_octet" -eq 3 ]] || [[ "$last_octet" -eq 4 ]] || [[ "$last_octet" -eq 5 ]] && { echo -e "Không chấp nhận giá trị octet ip cuối cùng bằng 0 -> 5"; exit ; }

	read -p "Điền Y ip lan đầu tiên: " start_lan
	check_number "${start_lan}"

	read -p "Điền số lượng ip Lan muốn tạo: " lan_numbers
	check_number "${lan_numbers}"
	
	add_ip
}

main

